using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EPiServer;
using EPiServer.Templates.ImageVault;
using ImageStoreNET.Developer;
using ImageStoreNET.Developer.Core;
using ImageStoreNET.Developer.Filters;

namespace ImageVaultDemoTemplates.templates.ImageVault.Pages {
    /// <summary>
    /// 
    /// </summary>
    /// <remarks></remarks>
    /// <example></example>
    public partial class Search : ImageVaultTemplate {
        /* *******************************************************************
        *  Properties 
        * *******************************************************************/

        /* *******************************************************************
        *  Constructors 
        * *******************************************************************/

        /* *******************************************************************
        *  Methods 
        * *******************************************************************/
        #region override protected void OnInit(EventArgs e)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        override protected void OnInit(EventArgs e) {
            InitializeComponent();
            base.OnInit(e);
        }
        #endregion
        #region private void InitializeComponent()
        /// <summary>
        /// 
        /// </summary>
        private void InitializeComponent() {
            Load += Page_Load;
            PreRender += Page_PreRender;
        }
        #endregion
        #region private void HandleSearch()
        /// <summary>
        /// 
        /// </summary>
        private void HandleSearch() {
            IVCategoryCollection catcriterias = new IVCategoryCollection();
            for (int i = 0; i < categories.Items.Count; i++) {
                if (categories.Items[i].Selected)
                    catcriterias.Add(new IVCategory(int.Parse(categories.Items[i].Value)));
            }

            IVMetaDataCollection metacriterias = new IVMetaDataCollection();
            for (int i = 0; i < pnlmetadata.Controls.Count; i++) {
                Control control = pnlmetadata.Controls[i];
                if (control is TextBox) {
                    TextBox tb = control as TextBox;
                    string sid = tb.ID.Substring(tb.ID.LastIndexOf('_') + 1);
                    int mid = int.Parse(sid);
                    if (tb.Text != string.Empty)
                        metacriterias.Add(new IVMetaData(mid, tb.Text));
                }
            }

            FileSearch.SortBy = IVFileSortBy.AlbumName;
            FileSearch.SearchQuery = SearchQuery.Text;
            FileSearch.MetaDataCriterias = metacriterias;
            FileSearch.CategoryCriterias = catcriterias;
            FileSearch.DataBind();
        }
        #endregion

        /* *******************************************************************
        *  Event methods 
        * *******************************************************************/
        #region void Page_PreRender(object sender, EventArgs e)
        /// <summary>
        /// This method is called when the Page's PreRender event has been fired.
        /// </summary>
        /// <param name="sender">The <see cref="object"/> that fired the event.</param>
        /// <param name="e">The <see cref="EventArgs"/> of the event.</param>
        void Page_PreRender(object sender, EventArgs e) {
            HandleSearch();
        }
        #endregion
        #region protected void Page_Load(object sender, EventArgs e)
        /// <summary>
        /// This method is called when the Page's Load event has been fired.
        /// </summary>
        /// <param name="sender">The <see cref="object"/> that fired the event.</param>
        /// <param name="e">The <see cref="EventArgs"/> of the event.</param>
        protected void Page_Load(object sender, EventArgs e) {
            if (!IsPostBack) {
                IVCategoryCollection catcoll = IVDataFactory.GetAllCategories();
                foreach (IVCategory catt in catcoll) {
                    categories.Items.Add(new ListItem(catt.Name, catt.Id.ToString()));
                }
            }

            IVMetaDataCollection metacoll = IVDataFactory.GetAllMetaData();
            foreach (IVMetaData meta in metacoll) {
                TextBox tb = new TextBox();
                tb.ID = "meta_" + meta.Id;
                Label label = new Label();
                label.Text = meta.Name;
                label.AssociatedControlID = tb.ID;
                pnlmetadata.Controls.Add(new LiteralControl("<span>"));
                pnlmetadata.Controls.Add(label);
                pnlmetadata.Controls.Add(tb);
                pnlmetadata.Controls.Add(new LiteralControl("</span>"));
            }
            if (!IsPostBack && SearchQuery.Text.Length == 0 && Request.QueryString["quicksearchquery"] != null)
                SearchQuery.Text = HttpContext.Current.Server.UrlDecode(Request.QueryString["quicksearchquery"]);            
        }
        #endregion
    }
}
