using System;
using System.Text;
using System.Web.UI;
using ImageStoreNET.Developer;
using ImageStoreNET.Developer.Core;

namespace ImageVaultDemoTemplates.templates.ImageVault.Pages {
    /// <summary>
    /// 
    /// </summary>
    /// <remarks></remarks>
    /// <example></example>
    public partial class WriteMetaData : Page {
        /* *******************************************************************
        *  Properties 
        * *******************************************************************/

        /* *******************************************************************
        *  Constructors 
        * *******************************************************************/

        /* *******************************************************************
        *  Methods 
        * *******************************************************************/
        #region override protected void OnInit(EventArgs e)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        override protected void OnInit(EventArgs e) {
            InitializeComponent();
            base.OnInit(e);
        }
        #endregion
        #region private void InitializeComponent()
        /// <summary>
        /// 
        /// </summary>
        private void InitializeComponent() {
            Load += new EventHandler(Page_Load);
        }
        #endregion
        /* *******************************************************************
        *  Event methods 
        * *******************************************************************/
        #region protected void Page_Load(object sender, EventArgs e)
        /// <summary>
        /// This method is called when the Page's Load event has been fired.
        /// </summary>
        /// <param name="sender">The <see cref="object"/> that fired the event.</param>
        /// <param name="e">The <see cref="EventArgs"/> of the event.</param>
        protected void Page_Load(object sender, EventArgs e) {
            try {
                if (Request.QueryString["imageUrl"] != null) {
                    IVFileData fileData =
                        IVDataFactory.GetFile(IVUrlBuilder.ParseUrl(Request.QueryString["imageUrl"]).Id);
                    StringBuilder html = new StringBuilder();
                    html.Append("<dl class=\"metadata clearfix\">");

                    // Conversion formats
                    if (fileData.ConversionFormats.Count > 0) {
                        html.Append("<dt>Available formats: </dt>");
                        html.Append("<dd>");
                        foreach (IVConversionFormat format in fileData.ConversionFormats) {
                            html.Append(format.Name + " ");
                        }
                        html.Append("</dd>");
                    }

                    // Categories
                    if (fileData.Categories.Count > 0) {
                        html.Append("<dt>Categories: </dt>");
                        html.Append("<dd>");
                        foreach (IVCategory category in fileData.Categories) {
                            html.Append(category.Name + " ");
                        }
                        html.Append("</dd>");
                    }

                    // General info
                    html.Append("<dt>Width: </dt>");
                    html.Append("<dd>");
                    html.Append(fileData.Width + " px");
                    html.Append("</dd>");
                    html.Append("<dt>Height: </dt>");
                    html.Append("<dd>");
                    html.Append(fileData.Height + " px");
                    html.Append("</dd>");
                    html.Append("<dt>File size: </dt>");
                    html.Append("<dd>");
                    html.Append(fileData.Length/1024 + " Kb");
                    html.Append("</dd>");
                    html.Append("<dt>File type: </dt>");
                    html.Append("<dd>");
                    html.Append(fileData.Extension);
                    html.Append("</dd>");

                    // Metadata
                    if (fileData.MetaData.Count > 0) {
                        IVAlbumData albumData = fileData.Album;
                        foreach (IVMetaData metaData in fileData.MetaData) {
                            // Don't show metadata not set on the album
                            if (albumData.MetaData[metaData.Name] == null) {
                                continue;
                            }
                            html.Append("<dt>" + metaData.Name + "</dt>");
                            html.Append("<dd>" + metaData.Value + "</dd>");
                        }
                    }
                    html.Append("</dl>");
                    Response.Write(html);
                }
            }
            catch {}
        }
        #endregion
    }
}