using System;
using EPiServer;
using ImageStoreNET.Developer;
using ImageStoreNET.Developer.Core;
using ImageStoreNET.Developer.WebControls;

namespace ImageVaultDemoTemplates.templates.ImageVault.Units {
    public partial class AlbumImageList : UserControlBase {
        /* *******************************************************************
        * Properties
        * *******************************************************************/
        #region public IVAlbumTree AlbumTreeControl
        /// <summary>
        /// Get/Sets the AlbumTreeControl of the AlbumImageList
        /// </summary>
        /// <value></value>
        public IVAlbumTree AlbumTreeControl {
            get { return _albumTreeControl; }
            set { _albumTreeControl = value; }
        }
        private IVAlbumTree _albumTreeControl;
        #endregion
        /* *******************************************************************
        * Methods
        * *******************************************************************/
        #region protected string GetImagePreviewLink(IVFileData fileData)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="fileData"></param>
        /// <returns></returns>
        protected string GetImagePreviewLink(IVFileData fileData) {
            IVUrlBuilder urlBuilder = new IVUrlBuilder();
            urlBuilder.Id = fileData.Id;
            urlBuilder.Width = 550;
            return urlBuilder.ToString();
        }
        #endregion
        #region protected string GetDownloadUrl(IVFileData fileData)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="fileData"></param>
        /// <returns></returns>
        protected string GetDownloadUrl(IVFileData fileData) {
            return IVUrlBuilder.GetDownloadUrl(fileData.Id);
        }
        #endregion
        #region override protected void OnInit(EventArgs e)
        override protected void OnInit(EventArgs e) {
            InitializeComponent();
            base.OnInit(e);
        }
        #endregion
        #region private void InitializeComponent()
        /// <summary>
        /// 
        /// </summary>
        private void InitializeComponent() {
            PreRender += Page_PreRender;
        }
        #endregion
        /* *******************************************************************
        *  Event methods 
        * *******************************************************************/
        #region protected void Page_PreRender(object sender, EventArgs e)
        /// <summary>
        /// This method is called when the Page's PreRender event has been fired.
        /// </summary>
        /// <param name="sender">The <see cref="object"/> that fired the event.</param>
        /// <param name="e">The <see cref="EventArgs"/> of the event.</param>
        protected void Page_PreRender(object sender, EventArgs e) {
            if (_albumTreeControl != null) {
                FileListControl.AlbumId = _albumTreeControl.OpenAlbum;
                FileListControl.DataBind();
            }
        }
        #endregion
    }
}