using System.Web;
using System.Web.UI.WebControls;

namespace EPiServer.Templates.ImageVault {
    /// <summary>
    /// Summary description for MetaDataVaules.
    /// </summary>
    /// <remarks>
    /// 2008-02-26 marcus: Created
    /// </remarks>
    public class UploadValues {
        private readonly UploadView uploadView;
        /* *******************************************************************
         *  Constructors 
         * *******************************************************************/
        #region internal UploadValues(UploadView uploadView)
        /// <summary>
        /// Initializes a new instance of the <b>MetaDataValues</b> class.
        /// </summary>
        /// <param name="uploadView"></param>
        internal UploadValues(UploadView uploadView) {
            this.uploadView = uploadView;
        }
        #endregion
        /* *******************************************************************
         *  Methods 
         * *******************************************************************/
        #region public string GetString(string name)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public string GetString(string name) {
            return (this.uploadView.FindControl(name) as TextBox).Text;
        }
        #endregion
        #region public HttpPostedFile GetFile(string name)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public HttpPostedFile GetFile(string name) {
            FileUpload fileUpload = uploadView.FindControl(name) as FileUpload;
            if (!fileUpload.HasFile)
                return null;
            return fileUpload.PostedFile;
        }
        #endregion
        #region public bool GetBool(string name)
        /// <summary>
        /// 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public bool GetBool(string name) {
            return (this.uploadView.FindControl(name) as CheckBox).Checked;
        }
        #endregion
    }
}